#include <Performer/pf/pfGeode.h>
#include "lim_global.h++"
#include "lim_perf.h++"
#include "lim_model.h++"


#define _LIM_PICKING_RAY_LENGTH 10000

static float mag;
/*
void hideSelectedDCS()
{
	g_selectedDCS->setTrans(0,-10,-2);
}

void hideSphereDCS()
{
	g_sphereDCS->setTrans(0,-10,-2);
}

void hideArrowDCS()
{
	g_arrowDCS->setTrans(0,-10,-2);
}

void showSelectedDCS(float x, float y, float z)
{
	g_selectedDCS->setTrans(x,y,z);
}


void showSphereDCS(float x, float y, float z)
{
	g_sphereDCS->setTrans(x,y,z);
	
}

void showArrowDCS(float x, float y, float z)
{
	g_arrowDCS->setTrans(x,y,z);
}
*/

float Itemizer(pfDCS *it)
{
  static float cenX, cenY, cenZ;
  static float lockedInHitLocation[3];
  float wandPos[3];
  float hitLocation[3];

  cvrnPrintf("item is:  %s\n", it->getName());

 if(strncmp(it->getName(), "two", 3)==0 || strncmp(it->getName(), "three", 5)==0 ||
    strncmp(it->getName(), "part", 4)==0)
   {
     CAVEGetPosition(CAVE_WAND, wandPos);

     // Grab the transform matrix of the selected object.
     pfMatrix m;
     it->getMat(m); float w;
     
     // Extract translation component of the performer object.
     m.getRow(3, &cenX, &cenY, &cenZ, &w);

     // Exact intersect of wand vector to object in world coord.
     CAVENavConvertCAVEToWorld(hitLocation,lockedInHitLocation);

     //showArrowDCS(lockedInHitLocation[0], lockedInHitLocation[1], lockedInHitLocation[2]);
     
     // Distance of intersect to wand.
     mag= fsqrt(((lockedInHitLocation[0] - wandPos[0]) * (lockedInHitLocation[0] - wandPos[0])) +
		((lockedInHitLocation[1] - wandPos[1]) * (lockedInHitLocation[1] - wandPos[1])) +
		((lockedInHitLocation[2] - wandPos[2]) * (lockedInHitLocation[2] - wandPos[2])));
     return mag;
   }
  
  return 0;
  
}

void Translator(pfDCS *tr, float mg, pfScene *sc)
{
  static int itemNum = 0;
  static float cenX, cenY, cenZ;
  static float lockedInHitLocation[3];
  float wandP[3], wandV[3];
  float newDat[3];

  if(strncmp(tr->getName(), "two", 3)==0 || strncmp(tr->getName(), "three", 5)==0 ||
     strncmp(tr->getName(), "part", 4)==0)
    {
		     
      // If there is one then allow you to move it.
      CAVEGetPosition(CAVE_WAND, wandP);
      CAVEGetVector(CAVE_WAND_FRONT,wandV);

      cvrnPrintf("x is:  %f\n", (wandP[0]+wandV[0] * mg)+.25);

      tr->setTrans((wandP[0]+wandV[0] * mg),
		   (wandP[1]+wandV[1] * mg)+.50,
		   (wandP[2]+wandV[2] * mg));

      if(strncmp(tr->getName(), "two", 3)==0)
	{
	  if((wandP[0]+wandV[0] * mg) > 4.0) { tr->setRot(0.0, 0.0, 90.0); }
	  if((wandP[0]+wandV[0] * mg) < -3.25) { tr->setRot(0.0, 0.0, 90.0); }
	  if((wandP[2]+wandV[2] * mg) < 3.0) { tr->setRot(0.0, 90.0, 0.0); }
	  if((wandP[0]+wandV[0] * mg) > -3.25 && (wandP[0]+wandV[0] * mg) < 4.0 &&
	     (wandP[2]+wandV[2] * mg) > 3.0) 
	    { tr->setRot(0.0, 90.0, 0.0); }
	}
      if(strncmp(tr->getName(), "part", 4)==0)
	{
	  if((wandP[0]+wandV[0] * mg) > 4.0) { tr->setRot(-90.0, 0.0, 0.0); }
	  if((wandP[0]+wandV[0] * mg) < -3.25) { tr->setRot(90.0, 0.0, 0.0); }
	  if((wandP[2]+wandV[2] * mg) < 3.0) { tr->setRot(0.0, 90.0, 0.0); }
	  if((wandP[0]+wandV[0] * mg) > -3.25 && (wandP[0]+wandV[0] * mg) < 4.0) 
	    { tr->setRot(0.0, 0.0, 0.0); }
	}

      // Place wand data into key for the object.
      CAVERN_irbKey_c *aKey = g_limListOfModelMetaDataKeys[itemNum];
      CAVERN_irbKey_c::status_t keyStatus;
      if (aKey) 
	{
	  int size = sizeof(float) * 3;
	  aKey->put((char*)newDat, &size, &keyStatus);
	}
    }
}


void conHandleSelectAndMove(pfScene *scene)
{
	static pfDCS *item = NULL;
	static pfDCS *navItem = NULL;
	pfDCS *pickedItem;
	static int itemNum = 0;
	static int navItemNum = 0;
	int selectedItemNum = 0;
	float wandPos[3];
	float magnitude = 0;

	pfSphere bsp;
	float hitLocation[3], worldHitLocation[3];
	static float lockedInHitLocation[3];
	

	pfDCS * doSelect(pfScene *, int*, float*);

	// Give feedback to user of what their wand is currently intersecting.
	pickedItem = doSelect(scene, &selectedItemNum, hitLocation);
	/*
	if (pickedItem) 
	  {
	    cvrnPrintf("pickedItem = %s\n", pickedItem->getName());
	    CAVEGetPosition(CAVE_WAND_NAV, wandPos);
	    CAVENavConvertCAVEToWorld(hitLocation,worldHitLocation);
	    showSelectedDCS(worldHitLocation[0],
			    worldHitLocation[1],
			    worldHitLocation[2]);
	    if(strncmp(pickedItem->getName(), "List", 4)==0)
	      {
		((kPartList *)(pickedItem))->HandleNameIsect();
	      }
	} else hideSelectedDCS();
	*/




	// If button pressed:
	if (CAVEBUTTON1) {


	  //hideSelectedDCS();
	   
		// If there is no item already in your hand then try and find one.
		if (item == NULL) {

			// Tell performer to do an intersection of a ray with the scene.
			item = doSelect(scene, &itemNum, hitLocation);

			// When an object has been selected figure out
			// what the current starting wand position is and
			// figure out where the exact point of intersection of the
			// wand ray to the selected object is.
			if (item)
			  {
			    magnitude = Itemizer(item);
			  }

		}
	    
		else { Translator(item, magnitude, scene); }
	}

	// If button 1 released release the object being moved.
	if (!CAVEBUTTON1) 
	  {      
	    item = NULL;
	    itemNum = 0;
	    //hideArrowDCS();
	  }

	// If button 2 hit then lock down the hit position so that we can 
	// subsequently interpolate towards the object.
	if (CAVEBUTTON2) 
	  {

	    //hideSelectedDCS();

		if (navItem == NULL) 
		  {
		    navItem = doSelect(scene, &navItemNum, hitLocation);
		    if (navItem)
		      {
			lockedInHitLocation[0] = hitLocation[0];
		     	lockedInHitLocation[1] = hitLocation[1];
		       	lockedInHitLocation[2] = hitLocation[2];
		       	float realHitLocation[3];

		       	// Exact intersect of wand vector to object in world coord.
		       	CAVENavConvertCAVEToWorld(hitLocation,realHitLocation);
			/*
		       	showSphereDCS(realHitLocation[0],
		       		      realHitLocation[1],
		       		      realHitLocation[2]);
				      */
		      }
		  }
	  }

	// If button 2 released then release the item we are interpolating towards.
	if (!CAVEBUTTON2) {
		navItem = NULL;
		//hideSphereDCS();
	}

	// We have an object we are interpolating towards.
	if (navItem) {
		float bodyPos[3];
		float deltaX, deltaY, deltaZ;
		CAVEGetPosition(CAVE_HEAD,bodyPos);
		deltaX = lockedInHitLocation[0] - bodyPos[0];
		deltaY = lockedInHitLocation[1] - bodyPos[1];
		deltaZ = lockedInHitLocation[2] - bodyPos[2];
		CAVENavTranslate(deltaX/20.0, deltaY/20.0, deltaZ/20.0);

		{
			// Make sure you can't navigate below the
			// ground.
			float headPos[3], localHeadPos[3];
			float diff;
			CAVEGetPosition(CAVE_HEAD_NAV, headPos);
			CAVEGetPosition(CAVE_HEAD,localHeadPos);
			diff = headPos[2] - localHeadPos[2];
			if (diff < 0) {
				CAVENavTranslate(0,0,-diff);
			}
		}
		
		lockedInHitLocation[0] -= (deltaX/20.0);
		lockedInHitLocation[1] -= (deltaY/20.0);
		lockedInHitLocation[2] -= (deltaZ/20.0);
	}

	
}

/* Go thru the array of intersections and take a look at each intersection */
pfNode * dealWithPicking(pfHit **hits[32], float hitLocation[3])
{
    int numObjects;
    int i;
    pfMatrix transformMatrix;
    pfVec3 transformedIsectPoint, isectPoint;

    // Get the path of only the first intersection.
    pfPath * path = NULL;
    (*hits[0])->query(PFQHIT_PATH, &path);

    // Figure out the point of intersection.
    (*hits[0])->query(PFQHIT_POINT, isectPoint.vec);

    (*hits[0])->query(PFQHIT_XFORM, (float*)transformMatrix.mat);

    transformedIsectPoint.xformPt(isectPoint, transformMatrix);
    hitLocation[0] = transformedIsectPoint[PF_X];
    hitLocation[1] = transformedIsectPoint[PF_Y];
    hitLocation[2] = transformedIsectPoint[PF_Z];

    pfNode * testIt;

    // Determine how many nodes are in the path
    numObjects = path->getNum();

    // Go thru each node in the path and see if it's name is "Jason".
    for(i=0; i<numObjects; i++) {
	    testIt = (pfNode *) path->get(i);
	
	    if (testIt != NULL) {
		    if (testIt->getName() != NULL) {
			    if ((strncmp(testIt->getName(), "Jason", 5) == 0) ||
			        (strncmp(testIt->getName(), "Radar", 5) == 0) ||
				(strncmp(testIt->getName(), "List", 4) == 0) ||
				(strncmp(testIt->getName(), "Name", 4) == 0)) {
				    return testIt;
			    }
		    }
	    }
    }

    return NULL;

}

/* Given a scene, do the selection by creating a performer ray with which
 to intersect the scene.
 */
pfDCS * doSelect(pfScene *hierarchy, int *itemNum, float hitLocation[3])
{
    pfSegSet segset;
    float wandVec[3];
    pfHit **hits[32];
    int isect = NULL;
    float rayStart[3];
 
    // set up for intersection testing
    //////////////////////////////////


    segset.mode		= PFTRAV_IS_PATH | PFTRAV_IS_GSET | PFTRAV_IS_CULL_BACK;
    segset.userData	= NULL;
    segset.activeMask	= 1;
    segset.isectMask	= 0x8;  // Intersection mask
    segset.bound	= NULL;
    segset.discFunc	= NULL;
     
    // need vector to start after the object currently in hand
    //////////////////////////////////////////////////////////

    CAVEGetPosition(CAVE_WAND,rayStart);
    CAVEGetVector(CAVE_WAND_FRONT,wandVec);


    // Set the location of the picking ray and the ray vector and its length
    segset.segs[0].pos.set(rayStart[0], rayStart[1], rayStart[2]);
    segset.segs[0].dir.set(wandVec[0], wandVec[1], wandVec[2]);
    segset.segs[0].length = _LIM_PICKING_RAY_LENGTH; // Length of the picking ray

    // see what the beam from the wand intersects
    /////////////////////////////////////////////

    // Hits contains an array of intersections.
    isect = hierarchy->isect(&segset, hits);

    pfDCS *selectedDCS;

    // If it has intersected something see if it is
    // something that has a mask of 0x8- ie our loaded objects.
    if (isect) {
	    selectedDCS = (pfDCS *) dealWithPicking(hits, hitLocation);

	    if (selectedDCS) 
	      {
		// Extract the name of the DCS (1st string is "Jason", "Radar, "List")
		// next value is the object number.
		char dummy[12];
		sscanf(selectedDCS->getName(),"%s %d",dummy, itemNum);
	      }
	    return selectedDCS;
    }
    return NULL;
		
}
