#ifndef _CONSOLE_H++
#define _CONSOLE_H++

#include <Performer/pf/pfScene.h>
#include <Performer/pr/pfLinMath.h>
#include "list.h"
#include "console_item.h++"
#include "console_MsgMgr.h++"

extern List<CAVERNst_baseAvatar_c> *current_users = new List<CAVERNst_baseAvatar_c>();

//MessageMgr *g_ConsoleMessageMgr;


#define MAX_TETHERS 10


class Console
{ 
private:

  int active_;

  pfScene *pfs_pointer;
  List<ConsoleItem> *current_items;
  
public:

  Console();
  ~Console();
    void ConsoleInit(int argc, int argv[], pfScene *env);
  void reportList();

  //void GetMessages();
  
  void addConsoleItem(const ConsoleItem * it);
  ConsoleItem removeConsoleItem(const ConsoleItem * it);

  void addUser(CAVERNst_baseAvatar_c *new_user);
  void removeUser(CAVERNst_baseAvatar_c *old_user);

  // command name passed in as a function name taking
  // *it_name as its parameter
  void invokeConsoleFunc(void (*invokeFunction)(char *), char *f_name)
  {
    void (*func)(char *);
    func = invokeFunction;            // invokeFunction = 
                                      //  hide(char *) | show(char *)
    (*func)(f_name);
  }
  
  // command name passed in as a function name taking
  // *it_name as its parameter
  void updateItem(void (*Update_ITEM_Attr)(char *), char *it_name)
  {
    void (*func)(char *);
    func = Update_ITEM_Attr;          // Update_ITEM_Attr = 
                                      //    hide(char *) | show(char *)
    (*func)(it_name);
  }

  void Update_User(void (*Update_USER_Attr)(char *), char *user_name)
  {
    void (*func)(char *);
    func = Update_USER_Attr;     // Update_USER_Attr = 
                                 //    highlight(char *) | 
                                 //    shareView(char *) |
                                 //    tether(char *)
    (*func)(user_name);
  }

  void hide(const char * it);
  void show(const char * it);
  
  void highlight(const char *u_name);

  void shareSend(int which, const char *u_name);
  void shareLinkTo(const char *u_name);
  void shareDetach(const char *u_name);

  void tetherSend(int which, const char *u_name);
  void tetherLinkTo(const char *u_name);
  void tetherDetach(const char *u_name);
  
};

extern Console *console = new Console();

#endif
