// CONSOLE

#include "console_global.h++"
#include "console_MsgMgr.h++"
#include "lim_user.h++"
#include "CAVERN.h++"
///////////////////////////////////////////////////
//
//
///////////////////////////////////////////////////
MessageMgr :: MessageMgr()
{
  messageList = new List<Message>;

}

MessageMgr :: ~MessageMgr()
{
  delete messageList;

}

void MessageMgr ::  registerMessage(const int msgType,
                                    consoleGlobal::_CHANNEL_TYPE channel,
           void (*cSCB)(CAVERNst_baseAvatar_c *, CAVERNplus_datapack_c *)=NULL,
           void (*cRCB)(CAVERNplus_datapack_c *)=NULL,
           void (*sSCB)(CAVERNst_baseAvatar_c *, CAVERNplus_datapack_c *)=NULL,
           void (*sRCB)(CAVERNplus_datapack_c *)=NULL)
{
  Message *newMsg = new Message();
  newMsg->setType(msgType);
  newMsg->setServerSendCallback(sSCB);
  newMsg->setServerRecCallback(sRCB);
  newMsg->setClientSendCallback(cSCB);
  newMsg->setClientRecCallback(cRCB);
  newMsg->setChannel(channel);

  messageList->Insert(newMsg);

}

Message * MessageMgr :: findMsg(const int type)
{
  messageList->SetFirst();
  while(messageList->InList()) 
  { 
    if(((Message*)messageList->curr->next->object)->getType()==type)
      return ((Message*) messageList->curr->next->object);
    else messageList->curr = messageList->curr->next;
  }
  return NULL;

  
}

void MessageMgr :: clientReceive(const int msgType, 
                                 CAVERNplus_datapack_c *data)
{
  Message *theMessage;
  cvrnPrintf("Client Receiving Message %d...\n", msgType);
  theMessage = findMsg(msgType);
  if (theMessage)
    {
      cvrnPrintf("Message Found! %d\n", msgType);
      if (theMessage->clientRecCB)
	{
	  cvrnPrintf("Calling Receiving Callback routine\n");
	  theMessage->clientRecCB(data);
	}
    }
}
void MessageMgr :: clientSend(const int msgType,
                              CAVERNst_baseAvatar_c *data)
{
  Message *theMessage;
  CAVERNplus_datapack_c datapack;
  cvrnPrintf("Client Sending...\n");
  theMessage = findMsg(msgType);
  if (theMessage)
    {
      cvrnPrintf("Message Found! %d\n", msgType);
      if (theMessage->clientSendCB)
	{
          if (theMessage->getChannel() == consoleGlobal::_USER_RELIABLE)
          {
	    cvrnPrintf("Sending _USER_RELIABLE data.\n");
            datapack.setBuffer(reliableBuffer, msgBufferSize);
            datapack.packInt(msgType);
	    cvrnPrintf("Calling Sending Callback routine\n");
	    theMessage->clientSendCB(data, &datapack);
	    limUserReliableSend(reliableBuffer,
				  msgBufferSize);
          }
          else if (theMessage->getChannel() == consoleGlobal::_USER_UNRELIABLE)
          {
            datapack.setBuffer(unReliableBuffer, msgBufferSize);
            datapack.packInt(msgType);
	    theMessage->clientSendCB(data, &datapack);
            limUserUnReliableSend(unReliableBuffer,
                            msgBufferSize);
          }
	  else cvrnPrintf("Error with:theMessage->getChannel(). Channel = %d\n", theMessage->getChannel());
	}
      else cvrnPrintf("Error with:theMessage->clientSendCB\n");
    }
}
void MessageMgr :: serverReceive(const int msgType,
                                 CAVERNplus_datapack_c *data)
{
  Message *theMessage;
  theMessage = findMsg(msgType);
  if (theMessage)
    {
      if (theMessage->serverRecCB)
	{
	  theMessage->serverRecCB(data);
	}
    }
}
void MessageMgr :: serverSend(const int msgType,
                                 CAVERNst_baseAvatar_c *data)
{
  Message *theMessage;
  CAVERNplus_datapack_c datapack;

  theMessage = findMsg(msgType);
  if (theMessage)
    {
      if (theMessage->serverSendCB)
	{
          datapack.setBuffer(serverBuffer, msgBufferSize);
          datapack.packInt(msgType);
	  theMessage->serverSendCB(data, &datapack);
          limServerReliableSend(serverBuffer,
                            msgBufferSize);
	}
    }
}

