/*
 * CONSOLE
 * 1/20/99
 * (C) 1999 
 * VT CAVE
 *
 */

#ifndef _CONSOLE_MSG_MGR
#define _CONSOLE_MSG_MGR

#include "lim_global.h++"
#include "list.h"
#include "console_global.h++"


class Message {
private:
  short messageType;
  consoleGlobal::_CHANNEL_TYPE channel;

protected:
public:

  Message(){};
  Message(int type){messageType = type;}
  void setType(int type) {messageType = type;}
  int getType() {return messageType;}

  void (*serverSendCB) (CAVERNst_baseAvatar_c *, CAVERNplus_datapack_c *); 
  void (*serverRecCB) (CAVERNplus_datapack_c * );
  void (*clientSendCB) (CAVERNst_baseAvatar_c *, CAVERNplus_datapack_c *);
  void (*clientRecCB) (CAVERNplus_datapack_c * );

  void setChannel(consoleGlobal::_CHANNEL_TYPE chan) { channel= chan;}
  consoleGlobal::_CHANNEL_TYPE getChannel() { return channel;}

  void setServerSendCallback(void (*cb)(CAVERNst_baseAvatar_c *, 
                                        CAVERNplus_datapack_c *)) 
  {serverSendCB = cb;}
  void setServerRecCallback(void (*cb)(CAVERNplus_datapack_c *)) 
  {serverRecCB = cb;}
  void setClientSendCallback(void (*cb)(CAVERNst_baseAvatar_c *,
                                        CAVERNplus_datapack_c *)) 
  {clientSendCB = cb;}
  void setClientRecCallback(void (*cb)(CAVERNplus_datapack_c *)) 
  {clientRecCB = cb;}



        // Messages introduced by the console

};

class MessageMgr {
private:
  List <Message> *messageList;
protected:
public:
  MessageMgr();
  ~MessageMgr();
  const msgBufferSize = 256;
  char reliableBuffer[msgBufferSize];
  char unReliableBuffer[msgBufferSize];
  char serverBuffer[msgBufferSize];
  void registerMessage(const int,
                  consoleGlobal::_CHANNEL_TYPE,
                  void (*cb)(CAVERNst_baseAvatar_c *, CAVERNplus_datapack_c *),
                  void (*cb2)(CAVERNplus_datapack_c *),
                  void (*cb3)(CAVERNst_baseAvatar_c *, CAVERNplus_datapack_c *),
                  void (*cb4)(CAVERNplus_datapack_c *));

  void clientReceive(const int, CAVERNplus_datapack_c *);
  void clientSend(const int, CAVERNst_baseAvatar_c *);
  void serverReceive(const int, CAVERNplus_datapack_c *);
  void serverSend(const int, CAVERNst_baseAvatar_c *);
  Message *findMsg(const int);



        // Messages introduced by the console

private:
protected:
public:
};

extern MessageMgr *g_ConsoleMessageMgr = new MessageMgr();

#endif




