/*
 * LIMBO
 * 4/3/98
 * (C) 1998 by Jason Leigh
 * Univ Illinois at Chicago
 *
 */

#include "lim_perf.h++"
#include "lim_navigate.h++"
#include "lim_audio.h++"
#include "lim_pick.h++"
#include "lim_model.h++"
#include "lim_avatar.h++"
#include "lim_user.h++"
//#include "console.h++"
#include "listen.h++"
//#include "con_pick.h++"


void limMainLoop()
{
  //*********CONSOLE CODE*************
  int items[3] = { egoFlatRadar, egoRadar, partList};
  console->ConsoleInit(3, items, g_limScene);
  //*********CONSOLE END**************
  
  catchInit();

  while (!CAVEgetbutton(CAVE_ESCKEY))
    {
      
      // Position and orient ray along wand.
      limUpdateWand();
      
      // This polls for any new objects that have
      // recently been downloaded.
      limCheckForNewObjectsToLoad();
      
      // Poll for when new avatars have arrived.
      CAVERNst_baseAvatar_c *new_av = limCheckForNewAvatars();
      if(new_av != NULL)
	{
	  console->addUser(new_av);
	}
      
      // Required by performer to synch things to a certain frame rate.
      pfSync();
      
      // Updates tracker data and sets up new projects for each channel.
      pfCAVEPreFrame();
      
      // Required by performer to trigger cull and draw
      pfFrame();
      
      // Updates non latency critical data.
      pfCAVEPostFrame();
      
      // Perform navigation in LIMBO
      limNavigate(g_limMainGroup);
      
      // Send your own avatar info to everyone
      limSendSelfAvatarTracker();
      
      // Handle the selection and movement of objects
      limHandleSelectAndMove(g_limScene);

      // Handle the selection and movement of console objects
      //conHandleSelectAndMove(g_limScene);

      // Handle LIMBO's voice intercom
      limHandleRecording();

      ListenForCommands(console);
      
      if (CAVEBUTTON1 && CAVEBUTTON2 && CAVEBUTTON3) break;
      
    }
  
  // Tell other participants that you are leaving the environment
  limAvatarExit();
  
  // Save away the state of the environment for resumption later
  limSaveModelMetaDataStates();

  termCatch();

  CAVEHalt();
  pfExit();

}
