//*************************************************************************
//*FILENAME:		LIST.CPP
//*AUTHOR:		Kevin Curry
//*PURPOSE:		Implements a doubly-linked class
//*************************************************************************/



#include "list.h"
#include <assert.h>
#include <iostream.h>


// constructor
template <class ConsoleObj>
List< ConsoleObj>::List() {
  tail = head = curr = new DblNode;
  // initialize the list
}

// destructor
template <class ConsoleObj>
List< ConsoleObj>::~List() {
  while(head != NULL) {
    curr = head;
    head = head->next;
    delete curr;
  }
}

template <class ConsoleObj>
void List<ConsoleObj>::Clear() {
  while(head->next != NULL) {
    curr = head->next;
    head->next = curr->next;
    delete curr;
  }
  
  curr = tail = head;		// reinitialize the list
}

template <class ConsoleObj>
void List<ConsoleObj>::Insert(const ConsoleObj* newObj) {

  SetFirst();
  
  if(curr == NULL) return;
  
  if(!IsEmpty())
    {
      curr = curr->next;
    }
  
  curr->next = new DblNode(newObj, curr->next, curr);
  
  if(curr->next->next != NULL)
    {
      curr->next->next->prev = curr->next;
    }
  
  if(tail==curr)  tail = curr->next;
  
}


template <class ConsoleObj>
void List<ConsoleObj>::Append(const ConsoleObj* newObj) 
{
  tail->next = new DblNode(newObj, NULL, tail->prev);
  tail = tail->next;
}

template <class ConsoleObj>
 ConsoleObj List<ConsoleObj>::Remove() {
  assert(InList());
  ConsoleObj *temp = curr->next->object;
  DblNode* tempNode = curr->next;
  if(tempNode->next != NULL)
    { tempNode->next->prev = curr; }
  else tail = curr;
  curr->next = tempNode->next;
  delete tempNode;
  
  return *temp;
}

template <class ConsoleObj>
void List<ConsoleObj>::Prev() {
  if(curr != NULL)  curr = curr->prev;
}

template <class ConsoleObj>
void List<ConsoleObj>::Next() {
  if (curr != NULL) curr = curr->next;
}

template <class ConsoleObj>
void List<ConsoleObj>::SetFirst() {
  curr = head;
}


template <class  ConsoleObj>
int List<ConsoleObj>::Find(const ConsoleObj* c) 
{
  // printf("finding:  %s\n", n);
  curr = head;
  while(InList()) 
  { 
    // printf("current name: %s\n", curr->next->object.GetName()); 
    //if(strncmp(curr->next->object.GetName(), n, 3)==0)
    if(curr->next->object == c)
      return 1;
    else curr = curr->next;
  }
  return 0;
}

template <class  ConsoleObj>
int List<ConsoleObj>::find(const char * c) 
{
  printf("List is finding:  %s\n", c);
  curr = head;
  while(InList()) 
  { 
    printf("current name: %s\n", curr->next->object->getName()); 
    if(strcmp(curr->next->object->getName(),c)==0)
      {
	printf("%s FOUND!\n", curr->next->object->getName()); 
	return 1;
      }
    else curr = curr->next;
  }
  printf("ERROR:  list find error!\n");
  return 0;
}

template <class  ConsoleObj>
int List<ConsoleObj>::find(int idNum) 
{
  printf("List is finding:  %d\n", idNum);
  curr = head;
  while(InList()) 
  { 
    printf("current name: %s\n", curr->next->object->getName()); 
    if(curr->next->object->getIDNumber() == idNum)
      {
	printf("%d FOUND!\n", curr->next->object->getIDNumber()); 
	return 1;
      }
    else curr = curr->next;
  }
  printf("ERROR:  list find error!\n");
  return 0;
}

template <class ConsoleObj>
int List<ConsoleObj>::IsEmpty() const {
  if(head->next==NULL) return 1;
  return 0;
}

template <class ConsoleObj>
int List<ConsoleObj>::InList() const {
  if ((curr != NULL) && (curr->next != NULL)) { return 1; }
  else { return 0; }
}


template <class ConsoleObj>
int List<ConsoleObj>::GetLength() const {
  int cnt = 0;
  if(!IsEmpty())
    {
      for(DblNode* temp = head->next;temp != NULL;temp = temp->next)
	{ cnt++; }
    }
  return cnt;
}

template <class ConsoleObj>
void List<ConsoleObj>::operator=(const List& l) {
  head = l.head;
  tail = l.tail;
  curr = l.curr;
  return;
}
