#ifndef LIST_H
#define LIST_H

#include <stddef.h>

template <class ConsoleObj>
class List{
private:
  class DblNode {
  public:
    DblNode* prev;
    DblNode* next;
    ConsoleObj *object;

    DblNode(DblNode* nextp = NULL, DblNode* prevp = NULL) 
      { next = nextp; prev = prevp; }

    DblNode(const  ConsoleObj* obj, DblNode* nxt = NULL, DblNode* prv= NULL)
      {  prev = prv; next = nxt; object = (ConsoleObj*)obj; }

    int DblNode::operator!=(const DblNode& node)
      {
	if(next == node.next && prev == node.prev)
	  {
	    //  char *s1 = (char *)part.GetString();
	    //  char *s2 = (char *)node.part.GetString();
	    //  if(strcmp(s1, s2)==0)
	      { return 0; }
	  }
	return 1;
      }
  };

public:
  DblNode* head;
  DblNode* tail;
  DblNode* curr;
  
  List();
  ~List();
  void Clear();
  void Insert(const  ConsoleObj* newObj);
  void Append(const  ConsoleObj* newObj);
  ConsoleObj Remove();
  void SetFirst();
  void SetLast();
  void Prev();
  void Next();
  int  GetLength() const;
  void setPosition(const int position);
  ConsoleObj GetValue() const;
  int GetShortest();
  int IsEmpty() const;
  int InList() const;
  int Find(const ConsoleObj* c);
  int find(const char * name);
  int find(int idNum);
  void operator=(const List& l);

};

#endif
