#ifndef _LISTEN_H++
#define _LISTEN_H++

#include <strings.h>
#include "catch.h"
#include "processor.h++"
#include "console.h++"

#define SIZE 16384 /* what's a little memory among friends? */

#define TELEPORT 1
#define HIGHLIGHT 2
#define SHOW 3
#define HIDE 4
#define TETHER 5
#define DETACH 6
#define OPEN 7
#define LOAD 8
#define SHAREVIEW 9
#define VIEW 10
#define NAVIGATE 11
#define UNCONFIRMED -11

void ListenForCommands(Console *con)
{
  char command[SIZE];
  int n = 0;
  
  char * params = NULL;     // pointer to command parameters
  
  n = catchData(command, SIZE);     // results are returned in 'command'
  
  if (n > 0)
   {
     cvrnPrintf("command is: %s\n", command);
   
     char cmd = command[0];

     cvrnPrintf("cmd = %c\n", cmd);

     params = index(command, ' ');     // point to the first space in 'command'
                                       // the command parameters start after
                                       // the first space (params+1)
     
     params++;     // advance pointer to next char (first char of parameters)

     switch(cmd)
       {
       case '1':
	 printf("tele_params = %s\n", params);
	 ProcessInput(con, TELEPORT, params);
	 break;

       case '2':
	 printf("h_params = %s\n", params);
	 ProcessInput(con, HIGHLIGHT, params);
	 break;
	 
       case '3':
	 printf("s_params = %s\n", params);
	 ProcessInput(con, SHOW, params);
	 break;

       case '4':
	 printf("sh_params = %s\n", params);
	 ProcessInput(con, HIDE, params);
	 break;

       case '5':
	 printf("tthr_params = %s\n", params);
	 ProcessInput(con, TETHER, params);
	 break;

       case '6':
	 printf("detach_params = %s\n", params);
	 ProcessInput(con, DETACH, params);
	 break;
	 
       case '7':
	 printf("o_params = %s\n", params);
	 ProcessInput(con, OPEN, params);
	 break;

       case '8':
	 printf("l_params = %s\n", params);
	 ProcessInput(con, LOAD, params);
	 break;
	 
       case '9':
	 printf("sv_params = %s\n", params);
	 ProcessInput(con, SHAREVIEW, params);
	 break;

       case '10':
	 printf("v_params = %s\n", params);
	 ProcessInput(con, VIEW, params);
	 break;

       case 'e':
	 printf("exiting\n");
	 break;
	 
       default:
	 printf("ERROR: command parse error!\n");
	 break;
       }
    
     return;
   }
  else return;
}
#endif
