#ifndef _PARTLIST_H
#define _PARTLIST_H

#include <Performer/pfdu.h>
#include <Performer/pf/pfGeode.h>
#include <Performer/pf/pfTraverser.h>
#include <Performer/pf/pfDCS.h>
#include <Performer/pr/pfLinMath.h>
#include <pfcave.h>
#include "console.h++"


#define MAX_COLLABORATORS 25

class PartList : public ConsoleItem
{
private:
  pfDCS *titleDCS;
  pfDCS *new_avDCS;
  pfText *new_avText;
  pfString *new_avString;
  pfText *titleText;
  int num_collaborators;
  pfVec3 position_;
  pfGroup *blips;
  float prevTime_;
  int active_;
  static pfType* classType_;
  pfFont *fnt;
  ItemType itemType;

  //class functions
public:
  PartList();
  ItemType GetItemType() { return itemType; }
  double getDistance(pfVec3, pfVec3);
  void HandleNameIsect();

  // overridden from ConsoleItem
public:
  void addUser(CAVERNst_baseAvatar_c *new_user);  
  void removeUser(CAVERNst_baseAvatar_c *old_user);
  void Update_ALL();   
  void Update_ONLY(char * name, int property);

/* Stuff required to make this a Performer class */
public:
  static void init(void);
  static pfType* getClassType(void){ return classType_; };

/* Stuff needed for APP traversal of node */
public:
  virtual int app(pfTraverser*);
  virtual int needsApp(void);
  int isActive();
};

#endif
