#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "listen.h++"

int ProcessInput(Console *con, int action, char * parameters)
{
  if(parameters != 0) 
    { cvrnPrintf("params are: %s\n", parameters); }

  switch(action)
    {
    case TELEPORT:

      if(isdigit(parameters[0]))
	{
	  cvrnPrintf("isdigit returned TRUE\n");
	  float coords[3];
	  coords[0] = 0.0; coords[1] = 0.0; coords[2] = 0.0;
	  sscanf(parameters, "%f %f %f", &coords[0],  &coords[1],  &coords[2]);
	  cvrnPrintf("coords[0] = %f\n", coords[0]);
	  cvrnPrintf("coords[1] = %f\n", coords[1]);
	  cvrnPrintf("coords[2] = %f\n", coords[2]);
	  CAVENavTranslate(coords[0],coords[1],coords[2]);
	  coords[0] = 0.0; coords[1] = 0.0; coords[2] = 0.0;
	}
      else
	{
	  cvrnPrintf("Not a DIGIT\n");
	  int numAvs = 0;     // #of avatars being tracked by the manager
	  
	  pfVec3 avatarPos;
	  
	  long avatarID;     // avDCSName is converted to an ID number,
	                     // which is required by the call to 
	                     // avatarDB->find(avatarID, theAvatar)
	  
	  CAVERNst_baseAvatar_c *theAvatar;     // pointer to an avatar in the 
	                                        // in the avatar database
	  
	  pfDCS *avatar;     // temp storage representing a single
	                     // avatar within g_limAvatarDCS
	  
	  // find out how many avatars are 
	  // currently being tracked
	  ////////////////////////////////
	  numAvs = current_users->GetLength(); 

	  cvrnPrintf("numAvs in Manager = %d\n", numAvs);
	  
	  if(numAvs > 0)
	    {
	      current_users->SetFirst();
	      // do this loop once for each avatar
	      ////////////////////////////////////
	      for (int j=0; j < numAvs; j++)
		{
		  theAvatar = (CAVERNst_baseAvatar_c*)current_users->curr->next->object;
		  
		  cvrnPrintf("theAvatar = %s\n", theAvatar->getName());

		  if(!strncmp(parameters, theAvatar->getName(), strlen(parameters)))
		    {
		      // get the avatar's position
		      ////////////////////////////
		      avatarPos[0] = theAvatar->bodyX;
		      avatarPos[1] = theAvatar->bodyY;
		      avatarPos[2] = theAvatar->bodyZ;

		      cvrnPrintf("(%f, %f, %f)\n", avatarPos[0], avatarPos[1], avatarPos[2]);

		      // Teleport
		      CAVENavTranslate(avatarPos[0]+3.0, avatarPos[1], avatarPos[2]);
		      return;
		    }
		  else current_users->Next();
		}
	   
	    }
    }
      break;

    case HIGHLIGHT:
      break;
      
    case SHOW:
      printf("SHOWING = %s\n", parameters);
      con->show(parameters);
      break;

    case HIDE:
      printf("HIDING = %s\n", parameters);
      con->hide(parameters);
      break;

    case TETHER:
      printf("TETHERING to %s\n", parameters);
      con->tetherSend(TETHER, parameters);
      break;

    case DETACH:
      printf("DETACHING from %s\n", parameters);
      con->tetherSend(DETACH, parameters);
      break;
      
    case OPEN:
      break;

    case LOAD:
      printf("LOADING %s\n", parameters);
      //con->load(parameters);
      break;
  
    case SHAREVIEW:
      printf("PROCESSING SHARE %s\n", parameters);
      con->shareSend(SHAREVIEW, parameters);
      break;

    case VIEW:
      break;

    case NAVIGATE:
      break;
    }

  return 1;
}


