#include "shareview.h++"

/************************************************************************/
/* Performer type data*/

pfType *ShareView::classType_ = NULL; 

void ShareView::init(void)
{
 if (classType_ == NULL)
   {
     pfDCS::init(); /* Initialize the parent class */

     // Create the new pfType for this class, based on the parent class's type
     classType_ =  new pfType(pfDCS::getClassType(), "ShareView");	
   }
}
/************************************************************************/

ShareView::ShareView()
{ 
  //shared = 0;
}

ShareView::ShareView(CAVERNst_baseAvatar_c * av)
{ 

  active_ = 1;     // initialize the flag
  sharedWith = av;

  pfVec3 avatarPos;

  // next 6 lines set up position
  ///////////////////////////////
  avatarPos.vec[0] = av->bodyX;
  avatarPos.vec[1] = av->bodyY;
  avatarPos.vec[2] = av->bodyZ;
  
  printf("Attempting share views at position (%f, %f, %f).\n", 
	 avatarPos.vec[0], avatarPos.vec[1], avatarPos.vec[2]);

  CAVENavLoadIdentity();
  CAVENavTranslate(avatarPos[0], avatarPos[1], avatarPos[2]);

  setName("ShareView");
  
  //ShareViewed = 1;

  //avatarOr.vec[0] = av->bodyAngleX;
  //avatarOr.vec[1] = av->bodyAngleY;
  //avatarOr.vec[2] = av->bodyAngleZ;

}

ShareView::~ShareView()
{ }


//**************************************************************
//  Function:   app
//  Purpose:    this is the programmer-defined Performer function 
//              that is automatically called each time Performer
//              traverses the scene graph
//  Parameters: pointer to the traverser
//  Returns:    void
//**************************************************************
int ShareView::app(pfTraverser *trav)
{
  // don't bother to continue if 
  // this object isn't active...
  //////////////////////////////
  if (!active_)
    {
      printf("SHAREVIEW NOT ACTIVE!\n");
      return pfDCS::app(trav);
    }
  else
    {
      // next 4 lines set up the input for updateCord
      ///////////////////////////////////////////////
      pfVec3 avatarPos;
      
      avatarPos.vec[0] = sharedWith->bodyX;
      avatarPos.vec[1] = sharedWith->bodyY;
      avatarPos.vec[2] = sharedWith->bodyZ;
      CAVENavLoadIdentity();
      CAVENavTranslate(avatarPos[0], avatarPos[1], avatarPos[2]);

      //printf("Update to: (%f, %f, %f)\n",
      //avatarPos.vec[0], avatarPos.vec[1], avatarPos.vec[2]);
    }
    
  return pfDCS::app(trav);
}

int ShareView::needsApp(void)
{
  return TRUE;
}


int ShareView::isActive()
{
  return active_;
}





