#include "tether.h++"

/************************************************************************/
/* Performer type data*/

pfType *Tether::classType_ = NULL; 

void Tether::init(void)
{
 if (classType_ == NULL)
   {
     pfDCS::init(); /* Initialize the parent class */

     // Create the new pfType for this class, based on the parent class's type
     classType_ =  new pfType(pfDCS::getClassType(), "Tether");	
   }
}
/************************************************************************/

Tether::Tether()
{ 
  //tethered = 0;
}

Tether::Tether(CAVERNst_baseAvatar_c * av)
{ 

  active_ = 1;     // initialize the flag
  tetheredTo = av;

  float avatarPos[3];

  // get the other guy's pos.
  //////////////////////////////
  avatarPos[0] = av->bodyX;
  avatarPos[1] = av->bodyY;
  avatarPos[2] = 0;
  
  printf("Attempting Tether to position (%f, %f, %f).\n", 
	 avatarPos[0], avatarPos[1], avatarPos[2]);

  CAVENavLoadIdentity();
  CAVENavTranslate(avatarPos[0]+5.0, avatarPos[1], avatarPos[2]);

  setName("Tether");
  
  //tethered = 1;

  //avatarOr.vec[0] = av->bodyAngleX;
  //avatarOr.vec[1] = av->bodyAngleY;
  //avatarOr.vec[2] = av->bodyAngleZ;

  //drawCord(avatarPos, scene);
}

Tether::~Tether()
{ 
  active_= 0;
}

void Tether::drawCord(pfVec3 tetherPoint, pfScene* pfs)
{
  printf("Attempting drawCord with endpoint (%f, %f, %f).\n", 
	 tetherPoint.vec[0], tetherPoint.vec[1], tetherPoint.vec[2]);

  //double dist;

  int len[1];
  pfVec3 myLoc, rayOr;

  newTetherDCS = new pfDCS;
  geode = new pfGeode;
  cord = new pfGeoSet;

  newTetherDCS->setName("tether");

  cord->setPrimType(PFGS_LINES);
  cord->setNumPrims(2);
  len[0] = 2;
  cord->setPrimLengths(len);
  
  pfVec4 *colorAttr = (pfVec4 *)pfMalloc(sizeof(pfVec4), pfGetSharedArena());
  colorAttr->vec[0] = 1.0f;     // RED
  colorAttr->vec[1] = 0.0f;
  colorAttr->vec[2] = 0.0f;
  colorAttr->vec[3] = 1.0f;
  
  cord->setAttr(PFGS_COLOR4,PFGS_OVERALL,colorAttr,NULL);
  
  CAVEGetPosition(CAVE_WAND, myLoc.vec);
  //CAVEGetOrientation(CAVE_WAND, rayOr.vec);
 
  pfVec3 coords[] = 
  {
    myLoc,
    tetherPoint
  }; 

  cord->setAttr(PFGS_COORD3, PFGS_PER_VERTEX, coords, NULL); 
  cord->draw();

  geode->addGSet(cord);
  newTetherDCS->addChild(geode);
  pfs->addChild(newTetherDCS);

  tethered = 1;

  //dist = getDistance(tetherPoint, myLoc);
  
  return;
}

void Tether::updateCord(pfVec3 new_endPt)
{

  cvrnPrintf("updating cord\n");

  pfVec3 myLoc;

  CAVEGetPosition(CAVE_WAND, myLoc.vec);
  //CAVEGetOrientation(CAVE_WAND, rayOr.vec);
 
  pfVec3 coords[] = 
  {
    myLoc,
    new_endPt
  }; 

  cord->setAttr(PFGS_COORD3, PFGS_PER_VERTEX, coords, NULL); 
  cord->draw();

  return;
}

//**************************************************************
//  Function:   app
//  Purpose:    this is the programmer-defined Performer function 
//              that is automatically called each time Performer
//              traverses the scene graph
//  Parameters: pointer to the traverser
//  Returns:    void
//**************************************************************
int Tether::app(pfTraverser *trav)
{
  // don't bother to continue if 
  // this object isn't active...
  //////////////////////////////
  if (!active_)
    {
      printf("TETHER NOT ACTIVE!\n");
      return pfDCS::app(trav);
    }
  else
    {
      // next 4 lines set up the input for updateCord
      ///////////////////////////////////////////////
      float avatarPos[3];
      
      avatarPos[0] = tetheredTo->bodyX;
      avatarPos[1] = tetheredTo->bodyY;
      avatarPos[2] = 0;
      CAVENavLoadIdentity();
      CAVENavTranslate(avatarPos[0]+5.0, avatarPos[1], avatarPos[2]);
      //printf("Update to: (%f, %f, %f)\n",
      //avatarPos.vec[0], avatarPos.vec[1], avatarPos.vec[2]);
      //updateCord(avatarPos);
    }
    
  return pfDCS::app(trav);
}

int Tether::needsApp(void)
{
  return TRUE;
}


int Tether::isActive()
{
  return active_;
}





