#ifndef _TETHER_H++
#define _TETHER_H++

#include <Performer/pfdu.h>
#include <Performer/pf/pfGeode.h>
#include <Performer/pf/pfTraverser.h>
#include <Performer/pf/pfDCS.h>
#include <Performer/pr/pfLinMath.h>
#include <pfcave.h>
#include "console.h++"

class Tether : public pfDCS
{
private:
  int active_;
  static pfType* classType_;

  int tethered;
  float cord_length;
  
  pfDCS *newTetherDCS;
  pfGeode *geode;
  pfGeoSet *cord;

  CAVERNst_baseAvatar_c *tetheredTo;

public:
  Tether();
  Tether(CAVERNst_baseAvatar_c *av);
  ~Tether();

  void drawCord(pfVec3 tetherPoint, pfScene *);
  void updateCord(pfVec3 new_endPt);
  void adjust(float len);

/* Stuff required to make this a Performer class */
public:
  static void init(void);
  static pfType* getClassType(void){ return classType_; };

/* Stuff needed for APP traversal of node */
public:
  virtual int app(pfTraverser*);
  virtual int needsApp(void);
  int isActive();

};


#endif
